|
Bugzilla – Full Text Bug Listing |
| Summary: | Checking for remap_pfn_range() no longer works | ||
|---|---|---|---|
| Product: | [openSUSE] SUSE Linux 10.1 | Reporter: | Stefan Dirsch <sndirsch> |
| Component: | Kernel | Assignee: | E-mail List <kernel-maintainers> |
| Status: | RESOLVED FIXED | QA Contact: | E-mail List <qa-bugs> |
| Severity: | Normal | ||
| Priority: | P5 - None | CC: | rguenther, ro, tiwai |
| Version: | Alpha 4 | ||
| Target Milestone: | --- | ||
| Hardware: | Other | ||
| OS: | Other | ||
| Whiteboard: | |||
| Found By: | Other | Services Priority: | |
| Business Priority: | Blocker: | --- | |
| Marketing QA Status: | --- | IT Deployment: | --- |
| Attachments: | Patch for segfault of modpost | ||
|
Description
Stefan Dirsch
2005-12-15 15:07:40 UTC
/usr/src/linux/include/asm/mpspec_def.h:
[...]
74 struct mpc_config_bus
75 {
76 unsigned char mpc_type;
77 unsigned char mpc_busid;
78 unsigned char mpc_bustype[6] __attribute((packed));
79 };
Richard, what do you think?
It's unfortunate ;) The attribute is ignored, because it doesn't make any difference if it is there or not. But the warning is stupid in this case. I'll report/fix upstream. Date: Thu, 15 Dec 2005 16:15:07 +0100 From: Takashi Iwai <tiwai@suse.de> To: research@suse.de Subject: Re: [Research] remap_page_range no longer available? > Of course I could simply remove the "-Werror" for us and maybe > convince NVIDIA to do the same for the next release. But I think it > would be better to fix this warning in the kernel sources or adjust > gcc to no longer complain about this. What do you think? Sure, better to fix the compile warnings. The __attribute((packed)) there looks superfluous to me. Takashi Ok. Then it makes sense to assign this to you, Richard. Thanks for the quick reply! Rudi added a workaround to nvidia-gfx package for now.
NVIDIA_kernel-1.0-8174-1438624.diff.txt:
diff -ru usr/src/nv/conftest.sh usr/src/nv.1438624/conftest.sh
--- usr/src/nv/conftest.sh 2005-11-23 03:22:31.000000000 +0100
+++ usr/src/nv.1438624/conftest.sh 2005-12-20 15:43:27.287128500 +0100
@@ -25,6 +25,13 @@
-nostdinc -isystem $ISYSTEM \
-Werror -Wimplicit-function-declaration"
+touch conftest$$.c
+$CC -Wno-attributes -c conftest$$.c > /dev/null 2>&1
+if [ $? -eq 0 ]; then
+ CFLAGS="$CFLAGS -Wno-attributes"
+fi
+rm -f conftest$$.*
+
if [ "$OUTPUT" != "$SOURCES" ]; then
CFLAGS="$CFLAGS -I$OUTPUT/include2 -I$OUTPUT/include \
-I$HEADERS -I$HEADERS/asm/mach-default"
Rudi, where does the patch come from? I couldn't find it on http://www.nvnews.net/vbulletin/showthread.php?t=61052.
Rudi, see my previous comment. the bad part about it is, that it helps for remap_page_range, but the build fails shortly afterwards: LD [M] /usr/src/packages/BUILD/obj/default/1.0-8174/nvidia.o Building modules, stage 2. MODPOST Warning: could not find /usr/src/packages/BUILD/obj/default/1.0-8174/.nv-kernel.o.cmd for /usr/src/packages/BUILD/obj/default/1.0-8174/nv-kernel.o /bin/sh: line 1: 20809 Segmentation fault scripts/mod/modpost -m -a -i /usr/src/linux-2.6.15-rc6-2-obj/x86_64/default/Module.symvers -s /dev/null /usr/ src/packages/BUILD/obj/default/1.0-8174/nvidia.o make[3]: *** [__modpost] Error 139 (same segfault on x86 and x86_64). modpost broken? I see a similar failure (new!) for the ati-fglrx package ... It looks like a bug in modpost. The patch below seems to work. Created attachment 61609 [details]
Patch for segfault of modpost
Takashi submitted the modpost patch to our kernel CVS. It's included by SuSE's kernel-of-the-day. Not a "bug" in gcc according to upstream, more like a kernel issue. Not working on it, so re-assigning. As per comment #12, I'm assuming this is solved then. Takashi, please make sure the fix goes upstream too! No, comments #8-12 discuss a different bug. Well, then, comment #5 still seems to indicate this is fixed? No, the patch of comment #5 has not been integrated in the released proprietary nvidia driver. The attribute has been removed upstream and thus in our latest kernels. Just ignoring bugs for long enough makes them magically better! Whee. ;-) |